<?
/*
   +-------------------------------------------------------------------------+
   | Copyright (c) 2002-2003 Roman Ivanov                                    |
   +-------------------------------------------------------------------------+
   | This program is copywrite Roman Ivanov <thingol@sky.ru> 2002-2003       |
   | All rights reserved.                                                    |
   | Using or distributing of this program must comply with terms of         |
   | license (contains in file README)                                       |
   | This notice must remain in the top of every                             |
   | document included in this distribution.                                 |
   +-------------------------------------------------------------------------+
   | Author: Roman Ivanov <thingol@sky.ru>                                   |
   +-------------------------------------------------------------------------+

*/
 //   
 require("config.php");

 // 
 $tick0 = timer_init();
 $tick  = timer_init();

 // ,  ,   :)
 $debug = 0;

 // 
 if ($debug<3) ob_start("ob_gzhandler");

 // 
 $debug_output=""; $nothtml = 0;

 // 
 debug("begin-Url-Constr");
  $req = &new HTTP_Request($baseurl);
  $req->setMethod($_SERVER["REQUEST_METHOD"]);
  if ($prox_host) $req->setProxy($prox_host, $prox_port, $prox_user, $prox_pass);
  $req->addHeader('Cookie', $cookies);
  $req->addHeader('User-Agent', "Mozilla/5.0 lj-php/".VERSION." (http://wiki.oversite.ru/LjPhp)");
  $req->addHeader('Accept', 'application/xhtml+xml,text/html,text/plain');
  $req->addHeader('Accept-Language', 'ru, en-us, en');
  $req->addHeader('Accept-Charset', 'windows-1251, utf-8');

  if (isset($_GET["lpurl"])) 
  {//    ""

   if ($debug>=2) $debug_output.='    ""<br>';
   $url_original = $_GET["lpurl"]; 
   $req->setURL($url_original);
   $lppage = $req->_url->path;
  } 
  else if (!isset($_REQUEST["lppage"]) && $_SERVER["REQUEST_URI"]!=$_SERVER["PHP_SELF"]) 
  {// 404

   if ($debug>=2) $debug_output.=' 404<br>';
   $uri = str_replace($root,"",$_SERVER["REQUEST_URI"]);

   $ps = strpos($uri, "?");
   if ($ps===false) 
   {
     $lppage = $uri;
     $query = "";
   } 
   else 
   {
     $lppage = substr($uri,0,$ps);
     $query = substr($uri,$ps+1,strlen($_SERVER["REQUEST_URI"])-$ps+1);
   }

   $url_original="http://".$baseurl.$lppage."?".$query;
   $req->setURL($url_original);
  } 
  else 
  {//    
   if ($debug>=2) $debug_output.='    <br>';

   $lppage = urldecode($_REQUEST["lppage"]);
   if (strpos($lppage, "/")!==0) $lppage = "/".$lppage;
   $ps = strpos($lppage, "?");
   if ($ps!==false) $lppage = substr($lppage,0,$ps);

   $query = "";
   foreach ($_GET as $key => $value) 
     if ($key!="lppage") 
       $query = $query.$key."=".urlencode($value)."&";
   $url_original = "http://".$baseurl.$lppage."?".$query;
   $url_original = rtrim($url_original, "&?");

   $req->setURL($url_original);

   if ($_SERVER["REQUEST_METHOD"]=="POST") 
     foreach ($_POST as $key => $value) 
       $req->addPostData($key, utf_encode($value), true);
     
  } 
  //..   $url_original, $lppage

  if (stristr($lppage, ".js")) { $debug = 0; $debug_output = ""; }

  $tu = parse_url($_SERVER["HTTP_REFERER"]);
  if ($is_service && $_COOKIE["_ljphp"]!=1 && $tu["host"]!=$_SERVER["SERVER_NAME"] && $lppage!="" && $lppage!="/")
  { 
   header("Location: ".$url_original);
   die();
  }
  else
   setcookie ("_ljphp", 1, time()+31536000, "/");

  //   
  $req->_url->removeQueryString("usescheme");
  $req->_url->removeQueryString("uselang");
  $req->_url->addQueryString("usescheme", $scheme, true);
  $req->_url->addQueryString("uselang", $lang, true);
  if ($s2sucks)
    $req->_url->addQueryString("style", "mine", true);
 debug("end-Url-Constr");

 //HTTP-Request
 debug("begin-Download");

  dtime("URL: ".$req->_url->GetUrl()."<br>Method: ".$req->_method."<br>Setted method: ".$_SERVER["REQUEST_METHOD"]);
  $req->sendRequest();
  $res = $req->getResponseBody();                           
  $in_cookies = explode("\n", $req->getRawResponseCookies());
  foreach ($in_cookies as $value)          
    if ($value!='') 
      header("Set-Cookie: ".$value);
//      preg_replace("/domain=.*?; /","",$value));
 dtime(" ");
 debug("end-Download");

 if (!stristr($req->_response->_headers["content-type"],"text/html")) 
 {
   $nothtml = 1;
   header ("Content-Type: ".$req->_response->_headers["content-type"]);
 }

 //   - DEBUG
 if ($debug>=2) 
 { 
  debug("begin-Save");
   $f=@fopen('debug.html', 'w');
   @fwrite($f, $res);
   @fclose($f);
  dtime(" ");
  debug("end-Save");
 }


 if (!$nothtml)
 {
  //
  debug("begin-Parse");
   $res = preg_replace("/\<meta[^>]*?utf-8[^>]*?\>/i","",$res);
   $res = str_replace("</head>","<meta http-equiv=\"Content-Type\" content=\"text/html; charset=".$charset."\" /></head>",$res);
   $res = R_absurl($res);
  debug("end-Parse");
  dtime(" ");

  //
  $res = utf_encode($res, "decode");
  debug("end-Recode");
  dtime(" ");
 }

 //   - DEBUG
 if ($debug>=2) 
 { 
  debug("begin-Save");
   $f=@fopen('debug2.html', 'w');
   @fwrite($f, $res);
   @fclose($f);
  dtime(" ");
  debug("end-Save");
 }


 //HTML-
 debug("begin-Output");
 if (!$nothtml && $a = strpos(strtoupper ($res), "<BODY")) 
 {
   $b = strpos($res, ">", $a);
   $res = substr($res,0,$b+1).$panel.' | <a href="'.$url_original.'">URL</a>'.$panel2.substr($res,$b+1);
 }

 echo $res;
 $tick1=timer_init();
 if ($debug) $debug_output .= "<p><b>  </b>: ".(number_format(($tick1-$tick0),3))." <br>";
 if ($debug && !$nothtml) echo "<font size='-2'>".$debug_output."</font>";
 debug("end-Output");

 // 
 if ($debug<3) ob_end_flush();
?>