<?
/*
   +-------------------------------------------------------------------------+
   | Copyright (c) 2002-2003 Roman Ivanov                                    |
   +-------------------------------------------------------------------------+
   | This program is copywrite Roman Ivanov <thingol@sky.ru> 2002-2003       |
   | All rights reserved.                                                    |
   | Using or distributing of this program must comply with terms of         |
   | license (contains in file README)                                       |
   | This notice must remain in the top of every                             |
   | document included in this distribution.                                 |
   +-------------------------------------------------------------------------+
   | Author: Roman Ivanov <thingol@sky.ru>                                   |
   +-------------------------------------------------------------------------+

*/
function debug($string) 
{
GLOBAL $debug, $debug_output;
  if ($debug>=3) echo "\n<!--DBG: ".$string."-->\n";
}

function dtime($string) 
{
GLOBAL $debug, $debug_output, $tick;
  $tick1=timer_init();
  if ($debug) $debug_output .= $string.": ".(number_format(($tick1-$tick),3))." <br>";
  $tick=timer_init();
}

function magicQuotesSuck(&$a)
{
  if (is_array($a))
  {
    foreach ($a as $k => $v)
    {
      if (is_array($v))
        magicQuotesSuck($a[$k]);
      else
        $a[$k] = stripslashes($v);
    }
  }
}

/*
function my_rtrim($what, $symbol)
{
 if (substr($what,strlen($what)-1)==$symbol) $what = substr($what,0,strlen($what)-1);
 return $what;
}
*/

function R_au ($url, $form = 0, $tail = "")
{
GLOBAL $baseurl, $root, $o404;
 if (!stristr ($url, "://")) 
 { //local
//  $host = $_SERVER["HTTP_HOST"].$root;
//  $url = $host."/".$url;
  $url = "/".$url;
  $url = str_replace("/./", "/", $url);
  while (stristr ($url, "//")) 
    $url = str_replace ("//", "/", $url);
  while (preg_match ("/\/([^\/\.]{1,})\/\.\.\//", $url)) 
    $url = preg_replace ("/\/([^\/\.]{1,})\/\.\.\//", "/", $url);
//  $url = "http://".$url;
 }
 $uri = parse_url($url);
 if ($uri["host"]==$baseurl || $uri["host"]=="")
   if ($o404!=1) $url = "http://".$_SERVER["HTTP_HOST"].$root."?lppage=".urlencode($uri["path"]).((strlen($uri["query"])>0)?"&".$uri["query"]:"");
   else          $url = "http://".$_SERVER["HTTP_HOST"].$root.$uri["path"].((strlen($uri["query"])>0)?"?".$uri["query"]:"");
 return $url;
}

function R_auf ($url, $tail = "")
{
GLOBAL $baseurl;
 $uri = parse_url($url);
 if ($uri["host"]==$baseurl || $uri["host"]=="")
   $url = "\"".$_SERVER["PHP_SELF"]."\" ".$tail.">".
          "<input type='hidden' name='lppage' value='".urlencode($uri["path"]).
          ((strlen($uri["query"])>0)?"?".$uri["query"]:"")."'>";
 else 
   $url = "\"".$url."\" ".$tail.">";
 return $url;
}


function R_absurl ($text)
{
// $text = preg_replace("/(href=)[\"\']?([^ \"\'>]*)[\"\']?/ie", "'$1\"'.R_au('$2').'\"'", $text); 
 $text = preg_replace("/(<a[^\>]*? href=|<img[^\>]*? src=|<script[^\>]*? src=)([\"\']?)([^ \\\\\"\'>]+)[\"\']?/ie", "stripslashes('$1').stripslashes('$2').R_au ('$3').stripslashes('$2')", $text); 
 $text = preg_replace("/(<form[^\>]*? action=)[\"\']?([^ \"\'\>]*)[\"\']?([^>]*?)\>/ie", "stripslashes('$1').R_auf ('$2', '$3')", $text); 
// $text = stripslashes($text);
 return $text;
}

function timer_init() {
 $ttt=microtime();
 $ttt=((double)strstr($ttt, ' ')+(double)substr($ttt,0,strpos($ttt,' ')));
 return $ttt;
}

function utf_encode($string, $direction = "encode") 
{
 GLOBAL $charset;

 //   strtr()
 $tran = array();
 $tran["windows-1251"] = array(
  "%A8"=>"%D0%81", "%B8"=>"%D1%91", "%C0"=>"%D0%90", "%C1"=>"%D0%91", "%C2"=>"%D0%92", "%C3"=>"%D0%93",
  "%C4"=>"%D0%94", "%C5"=>"%D0%95", "%C6"=>"%D0%96", "%C7"=>"%D0%97", "%C8"=>"%D0%98", "%C9"=>"%D0%99",
  "%CA"=>"%D0%9A", "%CB"=>"%D0%9B", "%CC"=>"%D0%9C", "%CD"=>"%D0%9D", "%CE"=>"%D0%9E", "%CF"=>"%D0%9F",
  "%D0"=>"%D0%A0", "%D1"=>"%D0%A1", "%D2"=>"%D0%A2", "%D3"=>"%D0%A3", "%D4"=>"%D0%A4", "%D5"=>"%D0%A5",
  "%D6"=>"%D0%A6", "%D7"=>"%D0%A7", "%D8"=>"%D0%A8", "%D9"=>"%D0%A9", "%DA"=>"%D0%AA", "%DB"=>"%D0%AB",
  "%DC"=>"%D0%AC", "%DD"=>"%D0%AD", "%DE"=>"%D0%AE", "%DF"=>"%D0%AF", "%E0"=>"%D0%B0", "%E1"=>"%D0%B1",
  "%E2"=>"%D0%B2", "%E3"=>"%D0%B3", "%E4"=>"%D0%B4", "%E5"=>"%D0%B5", "%E6"=>"%D0%B6", "%E7"=>"%D0%B7",
  "%E8"=>"%D0%B8", "%E9"=>"%D0%B9", "%EA"=>"%D0%BA", "%EB"=>"%D0%BB", "%EC"=>"%D0%BC", "%ED"=>"%D0%BD",
  "%EE"=>"%D0%BE", "%EF"=>"%D0%BF", "%F0"=>"%D1%80", "%F1"=>"%D1%81", "%F2"=>"%D1%82", "%F3"=>"%D1%83",
  "%F4"=>"%D1%84", "%F5"=>"%D1%85", "%F6"=>"%D1%86", "%F7"=>"%D1%87", "%F8"=>"%D1%88", "%F9"=>"%D1%89",
  "%FA"=>"%D1%8A", "%FB"=>"%D1%8B", "%FC"=>"%D1%8C", "%FD"=>"%D1%8D", "%FE"=>"%D1%8E", "%FF"=>"%D1%8F",
  );


 $tran["koi8-r"] = array(
  "%B3"=>"%D0%81", "%A3"=>"%D1%91", "%E1"=>"%D0%90", "%E2"=>"%D0%91", "%F7"=>"%D0%92", "%E7"=>"%D0%93",
  "%E4"=>"%D0%94", "%E5"=>"%D0%95", "%F6"=>"%D0%96", "%FA"=>"%D0%97", "%E9"=>"%D0%98", "%EA"=>"%D0%99",
  "%EB"=>"%D0%9A", "%EC"=>"%D0%9B", "%ED"=>"%D0%9C", "%EE"=>"%D0%9D", "%EF"=>"%D0%9E", "%F0"=>"%D0%9F",
  "%F2"=>"%D0%A0", "%F3"=>"%D0%A1", "%F4"=>"%D0%A2", "%F5"=>"%D0%A3", "%E6"=>"%D0%A4", "%E8"=>"%D0%A5",
  "%E3"=>"%D0%A6", "%FE"=>"%D0%A7", "%FB"=>"%D0%A8", "%FD"=>"%D0%A9", "%FF"=>"%D0%AA", "%F9"=>"%D0%AB",
  "%F8"=>"%D0%AC", "%FC"=>"%D0%AD", "%E0"=>"%D0%AE", "%F1"=>"%D0%AF", "%C1"=>"%D0%B0", "%C2"=>"%D0%B1",
  "%D7"=>"%D0%B2", "%C7"=>"%D0%B3", "%C4"=>"%D0%B4", "%C5"=>"%D0%B5", "%D6"=>"%D0%B6", "%DA"=>"%D0%B7",
  "%C9"=>"%D0%B8", "%CA"=>"%D0%B9", "%CB"=>"%D0%BA", "%CC"=>"%D0%BB", "%CD"=>"%D0%BC", "%CE"=>"%D0%BD",
  "%CF"=>"%D0%BE", "%D0"=>"%D0%BF", "%D2"=>"%D1%80", "%D3"=>"%D1%81", "%D4"=>"%D1%82", "%D5"=>"%D1%83",
  "%C6"=>"%D1%84", "%C8"=>"%D1%85", "%C3"=>"%D1%86", "%DE"=>"%D1%87", "%DB"=>"%D1%88", "%DD"=>"%D1%89",
  "%DF"=>"%D1%8A", "%D9"=>"%D1%8B", "%D8"=>"%D1%8C", "%DC"=>"%D1%8D", "%C0"=>"%D1%8E", "%D1"=>"%D1%8F",
  );

 $tran["x-mac-cyrillic"] = array(
  "%DD"=>"%D0%81", "%DE"=>"%D1%91", "%80"=>"%D0%90", "%81"=>"%D0%91", "%82"=>"%D0%92", "%83"=>"%D0%93",
  "%84"=>"%D0%94", "%85"=>"%D0%95", "%86"=>"%D0%96", "%87"=>"%D0%97", "%88"=>"%D0%98", "%89"=>"%D0%99",
  "%8A"=>"%D0%9A", "%8B"=>"%D0%9B", "%8C"=>"%D0%9C", "%8D"=>"%D0%9D", "%8E"=>"%D0%9E", "%8F"=>"%D0%9F",
  "%90"=>"%D0%A0", "%91"=>"%D0%A1", "%92"=>"%D0%A2", "%93"=>"%D0%A3", "%94"=>"%D0%A4", "%95"=>"%D0%A5",
  "%96"=>"%D0%A6", "%97"=>"%D0%A7", "%98"=>"%D0%A8", "%99"=>"%D0%A9", "%9A"=>"%D0%AA", "%9B"=>"%D0%AB",
  "%9C"=>"%D0%AC", "%9D"=>"%D0%AD", "%9E"=>"%D0%AE", "%9F"=>"%D0%AF", "%E0"=>"%D0%B0", "%E1"=>"%D0%B1",
  "%E2"=>"%D0%B2", "%E3"=>"%D0%B3", "%E4"=>"%D0%B4", "%E5"=>"%D0%B5", "%E6"=>"%D0%B6", "%E7"=>"%D0%B7",
  "%E8"=>"%D0%B8", "%E9"=>"%D0%B9", "%EA"=>"%D0%BA", "%EB"=>"%D0%BB", "%EC"=>"%D0%BC", "%ED"=>"%D0%BD",
  "%EE"=>"%D0%BE", "%EF"=>"%D0%BF", "%F0"=>"%D1%80", "%F1"=>"%D1%81", "%F2"=>"%D1%82", "%F3"=>"%D1%83",
  "%F4"=>"%D1%84", "%F5"=>"%D1%85", "%F6"=>"%D1%86", "%F7"=>"%D1%87", "%F8"=>"%D1%88", "%F9"=>"%D1%89",
  "%FA"=>"%D1%8A", "%FB"=>"%D1%8B", "%FC"=>"%D1%8C", "%FD"=>"%D1%8D", "%FE"=>"%D1%8E", "%DF"=>"%D1%8F",
  );


 $typo = array(
  "%C2%A7"=>"&#167;",
  "%C2%A9"=>"&#169;",
  "%C2%AB"=>"&#171;",
  "%C2%AE"=>"&#174;",
  "%C2%B0"=>"&#176;",
  "%C2%B1"=>"&#177;",
  "%C2%BB"=>"&#187;",
  "%E2%80%93"=>"&#150;",
  "%E2%80%94"=>"&#151;",
  "%E2%80%9C"=>"&#147;",
  "%E2%80%9D"=>"&#148;",
  "%E2%80%9E"=>"&#132;",
  "%E2%80%A6"=>"&#133;",
  "%E2%84%96"=>"&#8470;",
  "%E2%84%A2"=>"&#153;",
  "%C2%A4"=>"&curren;",
  "%C2%B6"=>"&para;",
  "%C2%B7"=>"&middot;",
  "%E2%80%98"=>"&#145;",
  "%E2%80%99"=>"&#146;",
  "%E2%80%A2"=>"&#149;",
 );
 //%C3%A9

 $rtran = array();
 $rtran["x-mac-cyrillic"] = array_flip($tran["x-mac-cyrillic"]);
 $rtran["windows-1251"]=array_flip($tran["windows-1251"]);
 $rtran["koi8-r"]=array_flip($tran["koi8-r"]);


 if ($direction == "encode")
   $string = strtr(urlencode($string),$tran[$charset]);
//   $string = strtr(urlencode(stripslashes($string)),$tran[$charset]);
 else 
 {
   $string = strtr(urlencode($string),$rtran[$charset]);
   $string = strtr($string,$typo);
   $string = urldecode($string);
 }
 return $string;
}

?>
